=== doc/Makefile ===
#*=====================================================================*/
#*    serrano/prgm/project/bigloo/doc/Makefile                         */
#*    -------------------------------------------------------------    */
#*    Author      :  Manuel Serrano                                    */
#*    Creation    :  Wed Jan 14 15:08:14 2004                          */
#*    Last change :  Fri Dec  1 10:22:23 2017 (serrano)                */
#*    Copyright   :  2004-17 Manuel Serrano                            */
#*    -------------------------------------------------------------    */
#*    The Makefile for managing the DOC Bigloo directory               */
#*=====================================================================*/

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:

#*---------------------------------------------------------------------*/
#*    population                                                       */
#*    -------------------------------------------------------------    */
#*    The list of all files that have to be placed inside the          */
#*    repository for revision.                                         */
#*---------------------------------------------------------------------*/
pop:
	@ echo doc/Makefile \
               doc/README.ppc doc/README.sgi \
               doc/README.alpha doc/README.openbsd \
               doc/README.finalizer doc/README.fp \
               doc/README.win32 doc/README.jvm \
               doc/README.athlon doc/README.pentium \
               doc/README.icc doc/README.benchmark \
               doc/README.hppa \
               doc/README.aix doc/README.aix.html \
               doc/README.sparc-linux \
               doc/README.mingw \
               doc/README.macosx doc/README.solaris \
               doc/README.android doc/README.raspberry

#*---------------------------------------------------------------------*/
#*    distrib                                                          */
#*---------------------------------------------------------------------*/
distrib:
